﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Data;
using System.Data.SqlClient;

namespace DataGridView_Filter_ComboBox_CS
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.PopulateComboBox();
            this.PopulateDataGridView();
        }

        private void cbCountries_SelectionChangeCommitted(object sender, EventArgs e)
        {
            this.PopulateDataGridView();
        }

        private void PopulateComboBox()
        {
            string query = "SELECT DISTINCT Country FROM Customers";
            string constr = @"Data Source=.\SQL2005;Initial Catalog=Northwind;User ID=sa;Password=pass@123";
            using (SqlConnection con = new SqlConnection(constr))
            {
                using (SqlDataAdapter sda = new SqlDataAdapter(query, con))
                {
                    //Fill the DataTable with records from Table.
                    DataTable dt = new DataTable();
                    sda.Fill(dt);

                    //Insert the Default Item to DataTable.
                    DataRow row = dt.NewRow();
                    row[0] = "";
                    dt.Rows.InsertAt(row, 0);

                    //Assign DataTable as DataSource.
                    cbCountries.DataSource = dt;
                    cbCountries.DisplayMember = "Country";
                    cbCountries.ValueMember = "Country";
                }
            }
        }

        private void PopulateDataGridView()
        {
            string query = "SELECT CustomerID, ContactName, Country FROM Customers";
            query += " WHERE Country = @Country";
            query += " OR ISNULL(@Country, '') = ''";
            string constr = @"Data Source=.\SQL2005;Initial Catalog=Northwind;User ID=sa;Password=pass@123";
            using (SqlConnection con = new SqlConnection(constr))
            {
                using (SqlCommand cmd = new SqlCommand(query, con))
                {
                    cmd.Parameters.AddWithValue("@Country", cbCountries.SelectedValue);
                    using (SqlDataAdapter sda = new SqlDataAdapter(cmd))
                    {
                        DataTable dt = new DataTable();
                        sda.Fill(dt);
                        dataGridView1.DataSource = dt;
                    }
                }
            }
        }
    }
}
